// -------------------------------------------
// DEFAULT INPUT AND OUTPUT AREA
let textarea = document.querySelector("#id_content");
if (textarea) {
  textarea.insertAdjacentHTML(
    "beforebegin",
    `<div id="markdown-editor">
  <div class="toolbar">
	<div class="group">		  
		<button type="button" id="undo-btn" class="disabled"><i class="fa fa-rotate-left"></i></button>
		<button type="button" id="redo-btn" class="disabled"><i class="fa fa-rotate-right"></i></button>
		<button type="button" id="eraser" class="disabled"><i class=" fa fa-eraser"></i></button>
	</div>
    <div class="group">
      <button type="button" id="heading1"><i class="fa fa-header" aria-hidden="true"></i>1</button>
      <button type="button" id="heading2"><i class="fa fa-header" aria-hidden="true"></i>2</button>
      <button type="button" id="heading3"><i class="fa fa-header" aria-hidden="true"></i>3</button>
      <button type="button" id="heading4"><i class="fa fa-header" aria-hidden="true"></i>4</button>
      <button type="button" id="heading5"><i class="fa fa-header" aria-hidden="true"></i>5</button>
      <button type="button" id="heading6"><i class="fa fa-header" aria-hidden="true"></i>6</button>
      <button type="button" id="hr"><i class="fa fa-header" aria-hidden="true"></i>R</button>
    </div>
    <div class="group">
      <button type="button" id="bold"><i class="fa fa-bold" aria-hidden="true"></i></button>
      <button type="button" id="italic"><i class="fa fa-italic" aria-hidden="true"></i></button>
      <button type="button" id="del"><i class="fa-solid fa-strikethrough"></i></button>
    </div>
    <div class="group">
      <button type="button" id="link"><i class="fa fa-link" aria-hidden="true"></i></button>
      <button type="button" id="img"><i class="fa fa-image" aria-hidden="true"></i></button>
    </div>
    <div class="group">
      <button type="button" id="inlinecode"><i class="fa fa-code" aria-hidden="true"></i></button>
      <button type="button" id="code"><i class="fa fa-xl fa-file-code" aria-hidden="true"></i></button>
    </div>
    <div class="group">
    </div>
    <div class="group">
      <button type="button" id="list-ul"><i class="fa fa-list-ul" aria-hidden="true"></i></button>
      <button type="button" id="list-ol"><i class="fa fa-list-ol" aria-hidden="true"></i></button>
      <button type="button" id="table"><i class="fa fa-table" aria-hidden="true"></i></button>
    </div>
    <button type="button" id="previewbtn"><i class="fa fa-eye" aria-hidden="true"></i></button>
  </div>  
  <div id="input-output">
    <div id="output-area"></div>
    <p class="preview-message">Preview Mode</p>
  </div>
</div>`
  );

  // -------------------------------------------
  // TOOLBAR
  // -------------------------------------------
  const previewbtn = document.querySelector("#previewbtn");
  const boldButton = document.querySelector("#bold");
  const delButton = document.querySelector("#del");
  const italicButton = document.querySelector("#italic");
  const heading1Button = document.querySelector("#heading1");
  const heading2Button = document.querySelector("#heading2");
  const heading3Button = document.querySelector("#heading3");
  const heading4Button = document.querySelector("#heading4");
  const heading5Button = document.querySelector("#heading5");
  const heading6Button = document.querySelector("#heading6");
  const hrButton = document.querySelector("#hr");
  const linkButton = document.querySelector("#link");
  const imgButton = document.querySelector("#img");
  const inlinecodeButton = document.querySelector("#inlinecode");
  const codeButton = document.querySelector("#code");
  const ulButton = document.querySelector("#list-ul");
  const olButton = document.querySelector("#list-ol");
  const tableButton = document.querySelector("#table");

  previewbtn.addEventListener("click", () => {
    output(parse(textarea.value));
    outputArea.classList.toggle("show");
    previewMessage.classList.toggle("show");
    previewbtn.classList.toggle("active");
  });

  boldButton.addEventListener("click", () =>
    insertText(textarea, "****", "demo", 2, 6)
  );
  delButton.addEventListener("click", () =>
    insertText(textarea, "~~~~", "del", 2, 5)
  );

  italicButton.addEventListener("click", () =>
    insertText(textarea, "**", "demo", 1, 5)
  );

  heading1Button.addEventListener("click", () =>
    insertText(textarea, "# ", "heading1", 2, 10)
  );

  heading2Button.addEventListener("click", () =>
    insertText(textarea, "## ", "heading2", 3, 11)
  );

  heading3Button.addEventListener("click", () =>
    insertText(textarea, "### ", "heading3", 4, 122)
  );
  heading4Button.addEventListener("click", () =>
    insertText(textarea, "#### ", "heading4", 5, 13)
  );
  heading5Button.addEventListener("click", () =>
    insertText(textarea, "##### ", "heading5", 6, 14)
  );
  heading6Button.addEventListener("click", () =>
    insertText(textarea, "###### ", "heading6", 7, 15)
  );
  hrButton.addEventListener("click", () =>
    insertText(textarea, "---", "", 3, 0)
  );

  linkButton.addEventListener("click", () =>
    insertText(textarea, "[]( URL )", " text ", 1, 7)
  );

  imgButton.addEventListener("click", () =>
    insertText(textarea, "![]( URL )", "alt image", 2, 11)
  );
  inlinecodeButton.addEventListener("click", () =>
    insertText(textarea, "``", "code", 1, 5)
  );
  codeButton.addEventListener("click", () =>
    insertText(textarea, "\r~~~ \r~~~", "code", 4, 10)
  );

  ulButton.addEventListener("click", function () {
    insertText(textarea, "* \r", "item", 2, 6);
  });

  olButton.addEventListener("click", () =>
    insertText(textarea, "1. \r", "item", 3, 7)
  );
  tableButton.addEventListener("click", () =>
    insertText(textarea,"\r| th | th | th |\r| :-- | :--: | --: |\r| td | td | td |\r","| td | td | td |\r\n",75, 75)
  );
}
// -------------------------------------------
function escapeHtml(text) {
  var map = {
    "#": "&#35;",
    "~": "&#126;",
    "(": "&#40;",
    ")": "&#41;",
    "{": "&#123;",
    "}": "&#125;",
    "[": "&#91;",
    "<": "&lt;",
    ">": "&gt;",
    '"': "&quot;",
    "'": "&#039;",
    "*": "&#42;"
  };
  return text.replaceAll(/[[(){}<>"'~*]/g, function (m) {
    return map[m];
  });
}

function setInputArea(inputElement) {
  textarea = inputElement;
}

function setOutputArea(outputElement) {
  outputArea = outputElement;
}

function insertText(
  textarea,
  syntax,
  placeholder = "demo",
  selectionStart = 0,
  selectionEnd = 0
) {
  // Current Selection
  const currentSelectionStart = textarea.selectionStart;
  const currentSelectionEnd = textarea.selectionEnd;
  const currentText = textarea.value;
  captureMemento();
  if (undoStack == '') undoStack[0] = ' ';
  if (currentSelectionStart === currentSelectionEnd) {
    const textWithSyntax = (textarea.value =
      currentText.substring(0, currentSelectionStart) +
      syntax +
      currentText.substring(currentSelectionEnd));
    textarea.value =
      textWithSyntax.substring(0, currentSelectionStart + selectionStart) +
      placeholder +
      textWithSyntax.substring(currentSelectionStart + selectionStart);

    textarea.focus();
    textarea.selectionStart = currentSelectionStart + selectionStart;
    textarea.selectionEnd = currentSelectionEnd + selectionEnd;
  } else {
    const selectedText = currentText.substring(
      currentSelectionStart,
      currentSelectionEnd
    );
    const withoutSelection =
      currentText.substring(0, currentSelectionStart) +
      currentText.substring(currentSelectionEnd);
    const textWithSyntax =
      withoutSelection.substring(0, currentSelectionStart) +
      syntax +
      withoutSelection.substring(currentSelectionStart);

    // Surround selected text
    textarea.value =
      textWithSyntax.substring(0, currentSelectionStart + selectionStart) +
      selectedText +
      textWithSyntax.substring(currentSelectionStart + selectionStart);

    textarea.focus();
    textarea.selectionEnd =
      currentSelectionEnd + selectionStart + selectedText.length;
  }
}

function output(lines) {
  outputArea.innerHTML = lines;
}

// -------------------------------------------
// PARSER
// -------------------------------------------

function parse(content) {
  // Regular Expressions
  const h1 = /^#{1}\s[^#].*$/gm;
  const h2 = /^#{2}\s[^#].*$/gm;
  const h3 = /^#{3}\s[^#].*$/gm;
  const h4 = /^#{4}\s[^#].*$/gm;
  const h5 = /^#{5}\s[^#].*$/gm;
  const h6 = /^#{6}\s[^#].*$/gm;
  const hr = /^( *[-*_]){3,} *(?:\n+|$)/gm;
  const inlinecode = /`[^\*\n]+`/gm;
  const code = /^~{3}((?!~{3})[^\*])+~{3}|^`{3}((?!`{3})[^\*])+`{3}/gm;
  const indentedCode = /^( {4}[^*\n]+\n*)+/gm;
  const bold = /\*\*[^\*\n]+\*\*/gm;
  const italics = /[^\*]\*[^\*\n]+\*/gm;
  const del = /~~[^\*\n]+~~/gm;
  const link = /\[[\w|\(|\)|\s|\*|\?|\-|\.|\,]*(\]\(){1}[^\)]*\)/gm;
  const img = /\![[\w|\(|\)|\s|\*|\?|\-|\.|\,]*(\]\(){1}[^\)]*\)/gm;


  const lists = /^((\s*((\*|\-)|\d(\.|\))) [^\n]+))+$/gm;
  const unorderedList = /^[\*|\+|\-]\s.*$/;
  const unorderedSubList = /^\s\s\s*[\*|\+|\-]\s.*$/;
  const orderedList = /^\d\.\s.*$/;
  const orderedSubList = /^\s\s+\d\.\s.*$/;
  
  const tables = /([^\n\r]*\|[^\r\n]*(\r?\n)?)+(?=(\r?\n)|$)/gm;
  
  // Example: # Heading 1
  if (h1.test(content)) {
    const matches = content.match(h1);

    matches.forEach((element) => {
      const extractedText = element.slice(1);
      content = content.replace(element, "<h1>" + extractedText + "</h1>");
    });
  }

  // Example: # Heading 2
  if (h2.test(content)) {
    const matches = content.match(h2);

    matches.forEach((element) => {
      const extractedText = element.slice(2);
      content = content.replace(element, "<h2>" + extractedText + "</h2>");
    });
  }

  // Example: # Heading 3
  if (h3.test(content)) {
    const matches = content.match(h3);

    matches.forEach((element) => {
      const extractedText = element.slice(3);
      content = content.replace(element, "<h3>" + extractedText + "</h3>");
    });
  }
  // Example: # Heading 4
  if (h4.test(content)) {
    const matches = content.match(h4);

    matches.forEach((element) => {
      const extractedText = element.slice(4);
      content = content.replace(element, "<h4>" + extractedText + "</h4>");
    });
  }
  // Example: # Heading 5
  if (h5.test(content)) {
    const matches = content.match(h5);

    matches.forEach((element) => {
      const extractedText = element.slice(5);
      content = content.replace(element, "<h5>" + extractedText + "</h5>");
    });
  }

  // Example: # Heading 6
  if (h6.test(content)) {
    const matches = content.match(h6);

    matches.forEach((element) => {
      const extractedText = element.slice(6);
      content = content.replace(element, "<h6>" + extractedText + "</h6>");
    });
  }

  // Example: hr --- *** ___
  if (hr.test(content)) {
    const matches = content.match(hr);

    matches.forEach((element) => {
      const extractedText = element;
      content = content.replace(element, "<hr>");
    });
  }

  // Example: ~~~code~~~
  if (code.test(content)) {
    const matches = content.match(code);

    matches.forEach((element) => {
      const extractedText = escapeHtml(element.slice(3, -4));
      content = content.replace(
        element,
        '<pre class="hljs html"><code class="language">' +
          extractedText +
          "</code></pre>"
      );
    });
  }
  // Example: `code`
  if (inlinecode.test(content)) {
    const matches = content.match(inlinecode);

    matches.forEach((element) => {
      const extractedText = escapeHtml(element.slice(1, -1));
      content = content.replace(
        element,
        ' <code class="language">' + extractedText + "</code>"
      );
    });
  }
  // Example: \n\n\n\ncode
  if (indentedCode.test(content)) {
    const matches = content.match(indentedCode);

    matches.forEach((element) => {
      const extractedText = escapeHtml(element.slice(3, -2));
      content = content.replace(
        element,
        '<pre class="hljs html" style="text-indent:2ch"><code class="language">' +
          extractedText +
          "</code></pre>"
      );
    });
  }
  // Example: **Bold**
  if (bold.test(content)) {
    const matches = content.match(bold);

    matches.forEach((element) => {
      const extractedText = element.slice(2, -2);
      content = content.replace(
        element,
        "<strong>" + extractedText + "</strong>"
      );
    });
  }
  // Example: ~~del~~
  if (del.test(content)) {
    const matches = content.match(del);

    matches.forEach((element) => {
      const extractedText = element.slice(2, -2);
      content = content.replace(element, "<del>" + extractedText + "</del>");
    });
  }

  // Example: *Italic*
  if (italics.test(content)) {
    const matches = content.match(italics);

    matches.forEach((element) => {
      const extractedText = element.slice(2, -1);
      content = content.replace(element, " <em>" + extractedText + "</em>");
    });
  }

  // Example: ![alt image](image.png)
  if (img.test(content)) {
    const imgs = content.match(img);
    imgs.forEach((element) => {
      const alt = element.match(/^\!\[.*\]/)[0].slice(2, -1);
      const url = element.match(/\]\(.*\)/)[0].slice(2, -1);
      content = content.replace(
        element,
        '<img src="' + url + '" alt="' + alt + '">'
      );
    });
  }

  // Example: [I'm an inline-style link](https://www.google.com)
  if (link.test(content)) {
    const links = content.match(link);

    links.forEach((element) => {
      const text = element.match(/^\[.*\]/)[0].slice(1, -1);
      const url = element.match(/\]\(.*\)/)[0].slice(2, -1);

      content = content.replace(
        element,
        '<a href="' + url + '">' + text + "</a>"
      );
    });
  }

  if (lists.test(content)) {
    const matches = content.match(lists);

    matches.forEach((list) => {
      const listArray = list.split("\n");

      const formattedList = listArray
        .map((currentValue, index, array) => {
          if (unorderedList.test(currentValue)) {
            currentValue = "<li>" + currentValue.slice(2) + "</li>";

            if (
              !unorderedList.test(array[index - 1]) &&
              !unorderedSubList.test(array[index - 1])
            ) {
              currentValue = "<ul>" + currentValue;
            }

            if (
              !unorderedList.test(array[index + 1]) &&
              !unorderedSubList.test(array[index + 1])
            ) {
              currentValue = currentValue + "</ul>";
            }

            if (
              unorderedSubList.test(array[index + 1]) ||
              orderedSubList.test(array[index + 1])
            ) {
              currentValue = currentValue.replace("</li>", "");
            }
          }

          if (unorderedSubList.test(currentValue)) {
            currentValue = currentValue.trim();
            currentValue = "<li>" + currentValue.slice(2) + "</li>";

            if (!unorderedSubList.test(array[index - 1])) {
              currentValue = "<ul>" + currentValue;
            }

            if (
              !unorderedSubList.test(array[index + 1]) &&
              unorderedList.test(array[index + 1])
            ) {
              currentValue = currentValue + "</ul></li>";
            }

            if (
              !unorderedSubList.test(array[index + 1]) &&
              !unorderedList.test(array[index + 1])
            ) {
              currentValue = currentValue + "</ul></li></ul>";
            }
          }

          if (orderedList.test(currentValue)) {
            currentValue = "<li>" + currentValue.slice(2) + "</li>";

            if (
              !orderedList.test(array[index - 1]) &&
              !orderedSubList.test(array[index - 1])
            ) {
              currentValue = "<ol>" + currentValue;
            }

            if (
              !orderedList.test(array[index + 1]) &&
              !orderedSubList.test(array[index + 1]) &&
              !orderedList.test(array[index + 1])
            ) {
              currentValue = currentValue + "</ol>";
            }

            if (
              unorderedSubList.test(array[index + 1]) ||
              orderedSubList.test(array[index + 1])
            ) {
              currentValue = currentValue.replace("</li>", "");
            }
          }

          if (orderedSubList.test(currentValue)) {
            currentValue = currentValue.trim();
            currentValue = "<li>" + currentValue.slice(2) + "</li>";

            if (!orderedSubList.test(array[index - 1])) {
              currentValue = "<ol>" + currentValue;
            }

            if (
              orderedList.test(array[index + 1]) &&
              !orderedSubList.test(array[index + 1])
            ) {
              currentValue = currentValue + "</ol>";
            }

            if (
              !orderedList.test(array[index + 1]) &&
              !orderedSubList.test(array[index + 1])
            ) {
              currentValue = currentValue + "</ol></li></ol>";
            }
          }
          return currentValue;
        })
        .join("");

      content = content.replace(list, formattedList);
    });
  }

  if (tables.test(content)) {
    const matches = content.match(tables);
    matches.forEach((element, index) => {
    element = element.trim();
    if (/^\|/g.test(element)) {
      let colAlign = [];
      let mytable = "";
      let cols = "";
      let myrows = "";
      let lines = element.split("\n");
      if (lines.length > 1 && lines[1].match(/^([\| -:]+)$/)) {
        let alignHeaders = lines[1].trim().slice(1, -1);
        let findcols = alignHeaders.split("|");
        findcols.forEach((align, index) => {
          let colalign = "";
          align = align.trim();
          if (/^:-/g.test(align)) colalign = ' align="left"';
          if (/.*-:$/g.test(align)) colalign = ' align="right"';
          if (/^:-.*-:$/g.test(align)) colalign = ' align="center"';
          colAlign[index] = colalign;
        });
        lines[1] = "";
      }
      lines.forEach((line, index) => {
        line = line.trim();
        let myrow = "";
        let start = "\r  <tr>\r   <td data-align>";
        let cell = "</td>\r   <td data-align>";
        let end = "</td>\r  </tr>";
        if (index == 0) {
          start = "\r  <tr>\r   <th data-align>";
          cell = "</th>\r   <th data-align>";
          end = "</th>\r  </tr>\r </thead>\r <tbody>";
        }
        if (line.length > 0) {
          myrow = line.trim();
          myrow = myrow.slice(1, -1);
          myrow = start + myrow + end;
          let findcols = myrow.split("|");
          myrow = myrow.replaceAll("|", cell);
          if (/data-align/gm.test(myrow)) {
            let alignement = myrow.match(/data-align/gm);
            alignement.forEach((align, index) => {
              myrow = myrow.replace(align, colAlign[index]);
            });
          }
          myrow = myrow.replace(/^\s+|\s+$|\s+(?=\s)/g, "");
          myrows += myrow;
        }
      });
      mytable = "<table>\r <thead>" + myrows + " </tbody>\r</table>\r\r";
      if (mytable.length > 0) content = content.replace(element, mytable);
    }
  });
}  
content = content.replace(/^\s+\s?|\n?\s?\s+$|\s+(?=\s)/g, "");
return content.split( '\n' ).map( line => {
		if( ! h1.test( line ) && ! h2.test( line ) && ! h3.test( line ) && ! h4.test( line ) && ! h5.test( line ) && ! h6.test( line ) && ! code.test( line )  && ! unorderedList.test( line ) && ! unorderedSubList.test( line ) && ! orderedList.test( line ) && ! orderedSubList.test( line ) ) {
			return line.replace( line, '<p>' + line + '</p>' );
		}
	} ).join( '' );
}

for (let e of document.querySelectorAll(
  ".lastcom-list a, .comment blockquote "
)) {
e.innerHTML = e.innerHTML.replace(/(<|&lt;)br\s*\/*(>|&gt;)/g,'');
if (e.getElementsByTagName("p")[0]) {
      let p = e.getElementsByTagName("p")[0];
      let br = e.getElementsByTagName("br")[0];
      let pCnt = e.getElementsByTagName("p")[0].innerHTML;
      e.removeChild(p);
      e.innerHTML = pCnt + e.innerHTML;
    }
  if (e.tagName === "A") {
    e.innerHTML = parse(e.innerHTML)
      .replace(/(<([^>]+)>)/gi, " ")
      .replace(/[\#\~]/gi, " "); // remove markdown/html if inside a link // personnal use
  } else {
    

    e.innerHTML = parse(e.innerHTML.replaceAll(/[<]br[^>]*[>]/gi, "\r"));
    let precode = e.querySelector("code");
    if (precode)
      precode.innerHTML = precode.innerHTML.replace(/(<([^>]+)>)/gi, "");
  }
}

document.querySelector("#input-output").appendChild(textarea);
let outputArea = document.querySelector("#output-area");
let previewMessage = document.querySelector(".preview-message");
//.replace(/g/gi, 'b')
// .replace(/<p.*>(.*?)<\/p>/gi, " $1 \r")

////////////

////////////////////////////////////////////////////
const undoButton = document.querySelector("#undo-btn");
const redoButton = document.querySelector("#redo-btn");
const eraseButton = document.querySelector("#eraser");

textarea.addEventListener("keydown", () => captureMemento());

// redo/undo function
const undoStack = [];
const redoStack = [];
const empty = Array().fill("");
// storing steps
const undo = () => {
  if(undoStack.length==0) {
    undoButton.classList.add("disabled")
    return;
  }
  const prevMemento = redoStack.push(textarea.value);
  const lastMemento = undoStack.pop();
  // reinstate the program state from memento
  if (lastMemento) textarea.value = lastMemento;
  const stack = lastMemento;
  updateUI(stack);
};

const redo = () => {
  if(redoStack.length==0 || redoStack.length == undoStack.length ) {
    redoButton.classList.add("disabled")
    return;
  }
  const lastMemento = undoStack.push(textarea.value);
  const prevMemento = redoStack.pop();
  // reinstate the program state from memento
  if (prevMemento) textarea.value = prevMemento;
  const stack = prevMemento;
  updateUI(stack);
};
// do it
const captureMemento = () => {
  // the memento is just the value of the textarea!
  const memento = textarea.value;
  undoStack.push(memento);
  redoStack.push(memento);
  updateUI();
};

// trigger undo/redo actions
undoButton.addEventListener("click", () => undo());
redoButton.addEventListener("click", () => redo());
eraseButton.addEventListener("click", function () {
  captureMemento();
  textarea.value = "";
  textarea.focus();
  this.classList.toggle("disabled");
});
// on undo/redo actions to perform
const updateUI = (stack) => {
  console.log("undo:" + undoStack.length + " redo:" + redoStack.length);

  if (undoStack.length) undoButton.classList.remove("disabled");
  else undoButton.classList.add("disabled");

  if (redoStack.length && redoStack.length != undoStack.length)
    redoButton.classList.remove("disabled");
  else redoButton.classList.add("disabled");

  if (textarea.value.length < 0 ) eraseButton.classList.add("disabled");
  else eraseButton.classList.remove("disabled");
  textarea.focus();
  //updatePreview();
};

///////////////////////////////////////////////////////
